/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 20, 2008
 * Time: 9:38:53 PM
 * Adapted version of HCard class removing immutable properties
 */
package org.microformats.hCard
import org.microformats.hCard.HCard
import org.microformats.hCard.HCard.*
import org.joda.time.DateTime
import org.joda.time.DateTimeZone
import org.joda.time.format.DateTimeFormatter
import org.joda.time.format.ISODateTimeFormat
import java.text.DateFormat
class hCard {
    public hCard() { }
    public hCard(fn, n, nicknames, photos, bday, adrs, labels, tels, emails, mailers, tz, geo, titles, roles, logos,
				agents, orgs, categories, notes, rev, sortString, sounds, uid, urls, accessClass, keys) {
        this.n = n;
        this.fn = n.toString()
        this.nicknames = nicknames
        this.photos = photos
        this.bday = bday
        this.adrs = adrs
        this.labels = labels
        this.tels = tels
        this.emails = emails
        this.mailers = mailers
        this.tz = tz
        this.geo = geo
        this.titles = titles
        this.roles = roles
        this.logos = logos
        this.agents = agents
        this.orgs = orgs
        this.categories = categories
        this.notes = notes
        this.rev = rev
        this.sortString = sortString
        this.sounds = sounds
        this.uid = uid
        this.urls = urls
        this.accessClass = accessClass
        this.keys = keys
    }

    String fn
	 HCard.Name n
	 def nicknames = [ ]
	 def  photos = [ ]
	 Long bday
	 def adrs = [ ]
	 def labels  = [ ]
	 def tels = [ ]
	 def emails = [ ]
	 def mailers = [ ]
	 Long tz
	 HCard.Geolocation geo
	 def titles = [ ]
	 def roles = [ ]
	 def logos = [ ]
	 def agents = [ ]
	 def orgs = [ ]
	 def categories = [ ]
	 def notes = [ ]
	 Long rev
	 String sortString
	 def sounds = [ ]
	 String uid
	 def urls = [ ]
	 String accessClass
	 List<String> keys = [ ]

private static final Map<Character, String> JSON_STRING_REPLACEMENTS;
	static {
		Map<Character, String> m = new HashMap<Character, String>();
		m.put('"', "\\\"");
		m.put('\\', "\\\\");
		m.put('\b', "\\b");
		m.put('\f', "\\f");
		m.put('\n', "\\n");
		m.put('\r', "\\r");
		m.put('\t', "\\t");
		JSON_STRING_REPLACEMENTS = Collections.unmodifiableMap(m);
	}

	 //from original
	 public @Override String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("hCard for ").append(fn).append('\n');
		if ( !n.isEmpty() ) sb.append("  Name: ").append(n).append('\n');
		if ( nicknames.size() > 0 ) sb.append("  Nickname: ").append(printCommaList(nicknames)).append('\n');
		if ( bday != null ) sb.append("  Birth day: ").append(printDate(bday.longValue())).append('\n');
		if ( tels.size() > 0 ) sb.append("  Tel Nr: ").append(printCommaList(tels)).append('\n');
		if ( emails.size() > 0 ) sb.append("  Email: ").append(printCommaList(emails)).append('\n');
		if ( geo != null ) sb.append("  Geolocation: ").append(geo).append('\n');
		if ( tz != null ) sb.append("  Timezone: ").append(tz).append('\n');
		if ( adrs.size() > 0 ) sb.append("  Address:\n").append(printBlockList(adrs));
		if ( labels.size() > 0 ) sb.append("  Label:\n").append(printBlockList(labels));
		if ( photos.size() > 0 ) sb.append("  Photo: ").append(printLineList(photos)).append('\n');
		if ( sounds.size() > 0 ) sb.append("  Sounds: ").append(printLineList(sounds)).append('\n');
		if ( mailers.size() > 0 ) sb.append(" Mailer:").append(printLineList(mailers)).append('\n');
		if ( titles.size() > 0 ) sb.append("  Title:").append(printCommaList(titles)).append('\n');
		if ( orgs.size() > 0 ) sb.append("  Organization: ").append(printLineList(orgs)).append('\n');
		if ( roles.size() > 0 ) sb.append("  Roles: ").append(printCommaList(roles)).append('\n');
		if ( logos.size() > 0 ) sb.append("  Logo: ").append(printLineList(logos)).append('\n');
		if ( agents.size() > 0 ) sb.append("  Agent: ").append(printLineList(agents)).append('\n');
		if ( categories.size() > 0 ) sb.append("  Category: ").append(printCommaList(categories)).append('\n');
		if ( urls.size() > 0 ) sb.append("  Url: ").append(printLineList(urls)).append('\n');
		if ( keys.size() > 0 ) sb.append("  Key: ").append(printBlockList(keys));
		if ( notes.size() > 0 ) sb.append("  Note: ").append(printBlockList(notes));
		if ( rev != null ) sb.append("  Rev: ").append(printDate(rev.longValue())).append('\n');
		if ( sortString != null ) sb.append("  SortString: ").append(sortString).append('\n');
		if ( uid != null ) sb.append("  UID: " ).append(uid).append('\n');
		if ( accessClass != null ) sb.append(" Class: ").append(accessClass).append('\n');

		return sb.toString();
	}

	//from original
	public String toHTML() {
		StringBuilder sb = new StringBuilder();

		sb.append("<div class=\"vcard\">");

		boolean orgCard = orgs.size() == 1 && orgs.get(0).name.equals(fn);
		sb.append("Contact information for <span class=\"fn").append(orgCard ? " org" : "").append("\">").append(s2h(fn)).append("</span><br />");

		if ( !orgCard ) {
			if ( n.isEmpty() ) sb.append("<span class=\"n\"></span>");
			else sb.append("Proper Name: ").append(n.toHTML());
		}

		sb.append(printStrings2HTMLLine(nicknames, "nickname", "Nickname", "Nicknames"));

		if ( bday != null ) sb.append("Birth Date: <span class=\"bday\">").append(date2s(bday)).append("</span><br />");

		for (  tel in tels ) sb.append(tel.toHTML());
		for ( HCard.Email email in emails ) sb.append(email.toHTML());
		if ( geo != null ) sb.append(geo.toHTML());
		if ( tz != null ) sb.append("Timezone: <span class=\"tz\">").append(tz2s(tz)).append("</span><br />");
		for ( HCard.Address adr in adrs ) sb.append(adr.toHTML());
		for ( String label in labels ) sb.append("Shipping Label: <div class=\"label\">").append(label).append("</div>");
		for ( URI photo in photos ) sb.append("<img class=\"photo\" src=\"").append(photo.toASCIIString()).append("\" /><br />");
		for ( URI url in urls ) sb.append("<a class=\"url\" href=\"").append(url.toASCIIString()).append("\">").append(s2h(url.toString())).append("</a><br />");

		if ( !orgCard ) for ( HCard.Organization org in orgs ) sb.append(org.toHTML());
		for ( URI logo in logos ) sb.append("<img class=\"logo\" src=\"").append(logo.toASCIIString()).append("\" /><br />");
		sb.append(printStrings2HTMLLine(roles, "role", "Role", "Roles"));

		sb.append(printStrings2HTMLLine(titles, "title", "Title", "Titles"));
		sb.append(printStrings2HTMLLine(categories, "category", "Category", "Categories"));
		sb.append(printStrings2HTMLLine(mailers, "mailer", "Mailer", "Mailers"));

		sb.append(printURIs2HTMLBlock(sounds, "sound", "Sound", "Sounds"));
		sb.append(printURIs2HTMLBlock(agents, "agent", "Agent", "Agents"));

		if ( keys.size() > 0 ) {
			sb.append("Key").append(keys.size() == 1 ? "" : "s").append(" :<br />");
			for ( String key in keys ) sb.append("<div class=\"key\">").append(s2h(key)).append("</div>");
		}

		if ( notes.size() > 0 ) {
			sb.append("Note").append(notes.size() == 1 ? "" : "s").append(" :<br />");
			for ( String note in notes ) sb.append("<div class=\"note\">").append(s2h(note)).append("</div>");
		}

		if ( rev != null ) sb.append("Last Updated: <span class=\"rev\">").append(date2s(rev)).append("</span><br />");
		if ( sortString != null ) sb.append("Sort String: <span class=\"sort-string\">").append(s2h(sortString)).append("</span><br />");
		if ( accessClass != null ) sb.append("Access class: <span class=\"class\">").append(s2h(accessClass)).append("</span><br />");
		if ( uid != null ) sb.append("UID: <span class=\"uid\">").append(s2h(uid)).append("</span><br />");

		sb.append("</div>");

		return sb.toString();
	}

	public String toJSON() {
		StringBuilder sb = new StringBuilder();

		sb.append('{');
		appendStringValue(sb, "fn", s2j(fn));
		appendStringValue(sb, "n", n.toJSON());
		if ( nicknames.size() > 0 ) appendStringValue(sb, "nicknames", sl2j(nicknames));
		if ( bday != null ) appendStringValue(sb, "bday", "" + bday);
		
		if ( tels.size() > 0 ) {
			sb.append("\"tels\":[");
			boolean first = true;
			for ( tel in tels ) {
				if ( first ) first = false;
				else sb.append(',');
				sb.append(tel.toJSON());
			}
			sb.append(']');
		}

		if ( emails.size() > 0 ) {
			sb.append("\"emails\":[");
			boolean first = true;
			for ( email in emails ) {
				if ( first ) first = false;
				else sb.append(',');
				sb.append(email.toJSON());
			}
			sb.append(']');
		}

		if ( geo != null ) appendStringValue(sb, "geo", geo.toJSON());
		if ( tz != null ) appendStringValue(sb, "tz", tz2s(tz));

		if ( adrs.size() > 0 ) {
			sb.append("\"adrs\":[");
			boolean first = true;
			for ( adr in adrs ) {
				if ( first ) first = false;
				else sb.append(',');
				sb.append(adr.toJSON());
			}
			sb.append(']');
		}

		if ( labels.size() > 0 ) appendStringValue(sb, "labels", sl2j(nicknames));
		if ( photos.size() > 0 ) appendStringValue(sb, "photos", sl2j(photos));
		if ( sounds.size() > 0 ) appendStringValue(sb, "sounds", sl2j(sounds));
		if ( mailers.size() > 0 ) appendStringValue(sb, "mailers", sl2j(mailers));
		if ( titles.size() > 0 ) appendStringValue(sb, "titles", sl2j(titles));

		if ( adrs.size() > 0 ) {
			sb.append("\"orgs\":[");
			boolean first = true;
			for ( org in orgs ) {
				if ( first ) first = false;
				else sb.append(',');
				sb.append(org.toJSON());
			}
			sb.append(']');
		}
		if ( roles.size() > 0 ) appendStringValue(sb, "roles", sl2j(roles));
		if ( logos.size() > 0 ) appendStringValue(sb, "logos", sl2j(logos));
		if ( agents.size() > 0 ) appendStringValue(sb, "agents", sl2j(agents));
		if ( categories.size() > 0 ) appendStringValue(sb, "categories", sl2j(categories));
		if ( urls.size() > 0 ) appendStringValue(sb, "urls", sl2j(urls));
		if ( keys.size() > 0 ) appendStringValue(sb, "keys", sl2j(keys));
		if ( notes.size() > 0 ) appendStringValue(sb, "notes", sl2j(notes));
		if ( rev != null ) appendStringValue(sb, "rev", "" + rev);
		if ( sortString != null ) appendStringValue(sb, "sort-string", s2j(sortString));
		if ( uid != null ) appendStringValue(sb, "uid", s2j(uid));
		if ( accessClass != null ) appendStringValue(sb, "class", s2j(accessClass));

		sb.setLength(sb.length() -1);
		sb.append('}');

		return sb.toString();
	}

	private String s2h(String x) {
		return x?.replaceAll("&", "&amp;")?.replaceAll("<", "&lt;")?.replaceAll(">", "&gt;");
	}

	private String printStrings2HTMLLine(List<String> items, String classValue, String singular, String plural) {
		if ( items.size() == 0 ) return "";
		String t = items.size() == 1 ? singular : plural;
		return String.format("%s: %s<br />", t, sl2h(items, classValue));
	}

	private String printURIs2HTMLBlock(List<URI> items, String classValue, String singular, String plural) {
		switch ( items.size() ) {
		case 0: return "";
		case 1: return singular + ": " + uri2ahref(items.get(0), classValue) + "<br />";
		default:
			StringBuilder sb = new StringBuilder();
			sb.append(plural).append(": <br /><ul>");
			for ( URI item in items ) sb.append("<li>").append(uri2ahref(item, classValue)).append("</li>");
			return sb.append("</ul>").toString();
		}
	}

	private String printCommaList(List<?> list) {
		boolean first = true;
		StringBuilder sb = new StringBuilder();
		for ( Object o in list ) {
			if ( first ) first = false;
			else sb.append(", ");
			sb.append(o);
		}

		return sb.toString();
	}

	private String sl2h(List<?> x, String classValue) {
		StringBuilder sb = new StringBuilder();
		boolean first = true;
		for ( Object s in x ) {
			if ( first ) first = false;
			else sb.append(", ");
			sb.append("<span class=\"").append(classValue).append("\">").append(s2h(s.toString())).append("</span>");
		}

		return sb.toString();
	}

	private String date2s(long millis) {
		DateTime dt = new DateTime(millis, DateTimeZone.UTC);
		DateTimeFormatter formatter = (dt.getSecondOfDay() == 0) ? ISODateTimeFormat.date() : ISODateTimeFormat.dateTimeNoMillis();
		return formatter.withZone(DateTimeZone.UTC).print(millis);
	}

	private String tz2s(Long tz) {
		int rawOffset = (int)(tz / (1000 * 60 * 60));
		return rawOffset + ":00"
	}

	private String s2a(String x) {
		return s2h(x).replaceAll("\"", "&quot;");
	}

	private String s2j(String x) {
		if ( x == null ) return "null";
		StringBuilder sb = new StringBuilder();
		sb.append('"');
		for ( int i = 0 ; i < x.length() ; i++ ) {
			char c = x.charAt(i);
			String replacement = JSON_STRING_REPLACEMENTS.get(c);
			if ( replacement != null ) sb.append(replacement);
			else if ( c >= 32 ) sb.append(c);
			else sb.append(String.format("\\u%04x", (int)c));
		}
		sb.append('"');

		return sb.toString();
	}

	private String sl2j(List<?> x) {
		StringBuilder sb = new StringBuilder();
		sb.append('[');
		boolean first = true;
		for ( Object s in x ) {
			if ( first ) first = false;
			else sb.append(',');
			sb.append(s2j(s.toString()));
		}
		sb.append(']');
		return sb.toString();
	}

	private String printDate(long millis) {
		return DateFormat.getDateInstance(DateFormat.MEDIUM, Locale.ENGLISH).format(new Date(millis));
	}

	private StringBuilder appendStringValue(StringBuilder sb, String name, String value) {
		return sb.append(s2j(name)).append(':').append(value).append(',');
	}

	private String printLineList(List<?> list) {
		if ( list.size() == 1 ) return list.get(0).toString();

		StringBuilder sb = new StringBuilder();
		for ( o in list ) sb.append("\n    ").append(o);
		return sb.toString();
	}

	private String printBlockList(List<?> list) {
		boolean first = true;
		StringBuilder sb = new StringBuilder();
		for ( o in list ) {
			if ( first ) first = false;
			else sb.append(" ---- \n");
			String item = o.toString();
			if ( item.endsWith("\n") ) item = item.substring(0, item.length() -1);
			sb.append("    ");
			sb.append(item.replaceAll("\n", "\n    "));
			sb.append('\n');
		}

		return sb.toString();
	}

	private String uri2ahref(URI item, String classValue) {
		return String.format("<a class=\"%s\" href=\"%s\">%s</a>", s2a(classValue), item.toASCIIString(), s2h(item.toString()));
	}
}