package org.microformats.hCard
/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 20, 2008
 * Time: 7:26:14 PM
 * To change this template use File | Settings | File Templates.
 */

import org.microformats.hCard.HCard
import org.microformats.hCard.HCard.*
import org.microformats.hCard.factory.factory.*
import java.util.logging.Logger

class hCardBuilder extends FactoryBuilderSupport {
    private static final Logger LOG = Logger.getLogger(hCardBuilder.name)
    public hCardBuilder() {

        registerBeanFactory("hcard", hCard)
        registerClasses()
        registerLists()
        registerSingleValues()
    }

    void registerClasses() {
        registerFactory("n", new NameFactory())
        registerFactory("geo", new GeoFactory())
        registerFactory("org", new OrganizationFactory())
        registerFactory("tel", new TelephoneFactory())
        registerFactory("email", new EmailFactory())
        registerFactory("adr", new AddressFactory())
    }

    void registerLists() {
        registerFactory("titles", new ListFactory())
        registerFactory("mailers", new ListFactory())
        registerFactory("notes", new ListFactory())
        registerFactory("roles", new ListFactory())
        registerFactory("labels", new ListFactory())
        registerFactory("keys", new ListFactory())
        registerFactory("categories", new ListFactory())
        registerFactory("nicknames", new ListFactory())
        registerFactory("sounds", new ListFactory())
        registerFactory("urls", new ListFactory())
        registerFactory("agents", new ListFactory())
        registerFactory("photos", new ListFactory())
    }

    void registerSingleValues() {
        registerFactory("bday", new ValueFactory())
        registerFactory("tz", new ValueFactory())
        registerFactory("rev", new ValueFactory())
        registerFactory("sortString", new ValueFactory())
        registerFactory("uid", new ValueFactory())        
    }
}
