/**
 * Created by IntelliJ IDEA.
 * User: jwill
 * Date: Feb 20, 2008
 * Time: 8:12:35 PM
 * To change this template use File | Settings | File Templates.
 */
package test
import org.microformats.hCard.*
import org.microformats.hCard.*
class HCardTestSuite extends GroovyTestCase {
    void testEmail() {
        def hCard = new hCardBuilder()
        def card = hCard.hcard {
            n(givenName:'John', familyName:'Doe')
            email(address:'name@email.com', types:['pref'])
        }
        assertTrue card.emails[0].value == 'name@email.com' && card.emails[0].types[0] == 'pref'
    }

    void testName() {
        def hCard = new hCardBuilder()
        def card = hCard.hcard {
            n(givenName:'John', familyName:'Doe')
            email(address:'name@email.com', types:['pref'])
        }
        println card.fn
        assertTrue card.n.givenName.equals('John') && card.n.familyName.equals('Doe') && card.fn.trim().equals('John Doe')
    }

    void testHCardParser() {
        def hCard = new hCardBuilder()
        def card = hCard.hcard {
            n(givenName: 'James', familyName:'Williams')
            tel(number:'703-555-9000 ext 555', types:['WORK'])
            org(name:'Sheraton Resorts', unit:'IT')
            email(address:'name@email.com',types:['pref'])
            adr(streetAddress:'11810 Sunrise Valley Drive', locality:'Reston', region:'VA', postalCode:'20191', countryName:'USA')
            titles(list:['hero','man'])
            bday(value:new Date())
            tz(value:'America/New_York')
        }

        def text = card.toHTML()
        def a = hCardParser.parseOne(text)
        assertTrue a instanceof hCard
    }

    void testGeo() {
       def hCard = new hCardBuilder()
        def card = hCard.hcard {
            n(givenName: 'James', familyName:'Williams')
            geo(latitude:'3', longitude:'0.345')
        }

        assertTrue card.geo.latitude == 3 && card.geo.longitude == 0.345
    }


    void testListFactory() {
       def hCard = new hCardBuilder()
        def card = hCard.hcard {
            n(givenName: 'James', familyName:'Williams')
            photos(list:['http://www.yahoo.com/photo'])
        }
        assertTrue card.photos[0] != null
    }
}